package zero1hd.polyjet.ui.pages;

import com.badlogic.gdx.math.Vector3;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.Slider;
import com.badlogic.gdx.scenes.scene2d.ui.Table;
import com.badlogic.gdx.utils.SnapshotArray;

import zero1hd.polyjet.audio.AudioAnalyzer;
import zero1hd.polyjet.audio.AudioData;

public class AnalyzePage extends Page {
	AudioAnalyzer audioAnalyzer;
	AudioData music;
	
	Vector3 cameraPos;
	
	Table songInfo;
	Slider difficultyModifier;
	Label difficultyModifierPercentage;
	
	public AnalyzePage(Skin skin, Vector3 camPos) {
		super("Results", skin);
		
		cameraPos = camPos;
		audioAnalyzer = new AudioAnalyzer();
		songInfo = new Table(skin);
	}
	
	public void setSong(AudioData music, SnapshotArray<Actor> uiMusicInfo) {
		cameraPos.x = 1.5f*getWidth();
		this.music = music;
		audioAnalyzer.startAnalyticalThread(music);
		
		addActor(songInfo);
		
		songInfo.add(uiMusicInfo.get(0)).spaceBottom(20f);
		songInfo.add(uiMusicInfo.pop()).expandX().center();
		songInfo.row();
		for (int currentActor = 1; currentActor < uiMusicInfo.size; currentActor++) {
			songInfo.add(uiMusicInfo.get(currentActor));
			songInfo.row();
		}
	}
	
	public boolean hasAudioData() {
		if (music != null) {
			return true;
		} else {
			return false;
		}
	}
	public void clearAUdioData() {
		music = null;
	}
}
